/*!
* \file localizable.hpp
* \brief Localizable object definition
 */

#pragma once

#include <gba.h>

namespace Astralbrew::Entity
{
	/*! \brief Abstract declaration of object dependent on its 2D position	
	 */
	class Localizable
	{
	public:
		/*!
		* \brief Get object x coordinate		
		* \return object x coordinate				
		 */
		virtual s16 pos_x() const = 0;
		
		/*!
		* \brief Get object y coordinate		
		* \return object y coordinate				
		 */
		virtual s16 pos_y() const = 0;
	};
}