#pragma once

#include <gba.h>
#include "AstralbrewEngine/memory/address.hpp"

namespace Astralbrew::Memory
{
	extern int ALC_DBG;
	
	class VramManager final
	{
	private:
		int id;
	public:
		VramManager(int offset, int length, int max_records_supported = 512);
		
		void reserve(Address* address, int size) const;
		void release(Address* address) const;
		void reset() const;
		
		~VramManager();
		
		static VramManager from_char_block(int id);
	};
}