#pragma once

#include "AstralbrewEngine/world/scene.hpp"
#include "AstralbrewEngine/types/vector.hpp"

namespace Astralbrew::Scenes
{
	class ListOption
	{
	private:
		const char* name;
		bool enabled;
	public:
		ListOption(const char* name, bool enabled = true);
		const char* get_name() const;
		bool is_enabled() const;
		void enable();
		void disable();
	};
	
	struct __SimpleListScene_internals;
	
	class SimpleListScene : public Astralbrew::World::Scene
	{
	private:		
		__SimpleListScene_internals* internals;
	protected:
		void select(int id);
	public:
		SimpleListScene();
		void init() override;
		void frame() override;
		void on_key_down(int keys) override;
		virtual void on_selection_done(int index);
		virtual void on_cancel_triggered();				
		~SimpleListScene();
		
		int add_item(ListOption* option);
		int add_item(const char* text, bool enabled = true);
	};	
}