#pragma once
#include "AstralbrewEngine/debug/error.hpp"
#include "AstralbrewEngine/world/schedule.hpp"

namespace Astralbrew::World
{		
	struct SceneCom;	

	class Scene : public Schedule
	{
	private:		
		int wait_key = 0;						
	public:
		Scene() = default;		
		SceneCom* close();
		void wait_for_key_pressed(int key);						
		
		virtual void init() = 0;
		virtual void frame() = 0;		
		virtual void before_frame();
		
		__attribute__((noinline))
		virtual void run();
		virtual void on_key_down(int keys) {}
		virtual void on_key_held(int keys) {}
		virtual void on_key_up(int keys) {}		
		virtual ~Scene() = default;		
	};	
		
	struct SceneCom
	{							
		void next(Scene* new_scene);		
	};	

	extern Scene* __MAIN_SCENE__;	
	
	extern void init_main_scene();

	#ifdef ASTRALBREW_IMPL	
	extern SceneCom __SceneComInstance__;	
	#endif
}