#pragma once

#include "AstralbrewEngine/types/vector.hpp"

namespace Astralbrew::World
{
	class ScheduledTask
	{
	private:
		int frame_lapse;
		int counter;
	protected:
		ScheduledTask(int frame_lapse, int counter = -1);
	public:				
		void execute();
		
		void set_counter(int cnt);

		bool is_active() const;
		
		int get_frame_lapse() const;
		
		virtual void action() = 0;

		virtual ~ScheduledTask() = default;
		
		static const int CNT_INF;
		static int seconds(int s);
	};
	
	class Schedule
	{
	private:
		Vector<ScheduledTask*> tasks;
		Vector<int> frame_joined;
		int counter = 0;
	public:
		void schedule_task(ScheduledTask* task);
		void unschedule_task(ScheduledTask* task);
	protected:
		void run_frame();
	};
}